Unit ASG1C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ASG1C(var A :Array of Complex; var B :Array of Complex;
                var X :Array of Complex; var S :Array of Integer;
                N :Integer; P :Integer);

implementation

procedure ASG1C(var A :Array of Complex; var B :Array of Complex;
                var X :Array of Complex; var S :Array of Integer;
                N :Integer; P :Integer);
var
F,L,M,I,J,K,I1,BG :Integer;
BJ,BN :Real;
BX,PR,Z,W,R :Complex;
const
ZERO :Complex = ( re:0.0; im:0.0 );
label
_15,_1,_2,_3,_4,_5,_6,_7,_8,_9,_11,_12,_13;
begin
if ( N > 1 ) 
 then goto _15;
if ( N <= 0 ) 
 then goto _13;
X[N-1] := DivC(B[N-1],A[(N-1)+(N-1)*N]);
goto _13;
_15:
if ( P <> 1 ) 
 then goto _6;
F := 0;
_1:
F := F+1;
BG := F;
BJ := Creal(ZERO);
for I:=F to N do
 begin
  BN := Cabs(A[(I-1)+(F-1)*N]);
  if ( BJ >= BN ) 
   then goto _2;
  BJ := BN;
  BG := I;
_2:
 end;
for J:=1 to N do
 begin
  BX := A[(BG-1)+(J-1)*N];
  A[(BG-1)+(J-1)*N] := A[(F-1)+(J-1)*N];
_3:
  A[(F-1)+(J-1)*N] := BX;
 end;
S[F-1] := BG;
PR := DivC(Cmplx(1.0,0.E0),A[(F-1)+(F-1)*N]);
L := F+1;
for I:=L to N do
 begin
_4:
  A[(I-1)+(F-1)*N] := SubC(Cmplx(0.0,0.0),MulC(PR,A[(I-1)+(F-1)*N]));
 end;
for J:=L to N do
 begin
  for I:=L to N do
   begin
_5:
    A[(I-1)+(J-1)*N] := AddC(A[(I-1)+(J-1)*N],MulC(A[(F-1)+(J-1)*N],A[(I-1)+(F-1)*N]));
   end;
 end;
if ( L-N ) < 0
 then goto _1
 else if ( L-N ) > 0
       then goto _6
       else goto _6;
_6:
for I:=1 to N do
 begin
_7:
  X[I-1] := B[I-1];
 end;
M := N-1;
for I:=1 to M do
 begin
  I1 := S[I-1];
  Z := X[I1-1];
  X[I1-1] := X[I-1];
_8:
  X[I-1] := Z;
 end;
for J:=1 to M do
 begin
  W := X[J-1];
  K := J+1;
  for I:=K to N do
   begin
_9:
    X[I-1] := AddC(X[I-1],MulC(A[(I-1)+(J-1)*N],W));
   end;
 end;
X[N-1] := DivC(X[N-1],A[(N-1)+(N-1)*N]);
if ( N = 1 ) 
 then goto _13;
K := N;
for I:=1 to M do
 begin
  R := Cmplx(0.0,0.E0);
  L := K-1;
  for J:=K to N do
   begin
_11:
    R := AddC(R,MulC(A[(L-1)+(J-1)*N],X[J-1]));
   end;
  K := N-I;
_12:
  X[K-1] := DivC((SubC(X[K-1],R)),A[(K-1)+(K-1)*N]);
 end;
_13:
end;

end.
